;; 
;; Author: David Krentzlin
;; 
;; Created: Do Nov 18 18:19:54 2010 (CET)
;; Last-Updated: Sa Nov 20 09:19:22 2010 (CET)
;;           By:

(use nomads nomads-sql-de-lite fmt fmt-color filepath)

(migration-directory "./migrations")
(database-credentials "test.db")

(define (get-version)
  (let ((version (get-environment-variable "VERSION")))
    (if version
        (or (string->number version) (string->symbol version))
        'latest)))


(define (pretty-print-migration checkpoint irreversible?)
  (let ((direction (car checkpoint))
        (migration (cdr checkpoint)))
    (fmt #t
     (pad-char #\.
               (cat "["
                    (fmt-bold (migration-version migration))
                    "] "
                    (filepath:drop-extension (migration-filename migration))
                    " "
                    (space-to 72)
                    "["
                    (fmt-bold (if irreversible? (fmt-red "IRREVERSIBLE")  (fmt-green "OK")))
                    "]")))
    (newline)))


(migrate version: (get-version) callback: pretty-print-migration)
